package com.nisum.operators.error;

import java.time.Duration;

import com.nisum.util.SubscriberUtil;

import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public class HandlingError {

	public static void main(String[] args) {
//		tryCatch();
		error();
//		onErrorMap();
//		onErrorReturn();
//		onErrorResume();
	}

	public static void tryCatch() {

		Flux<Integer> flux = null;

		try {
			flux = Flux.range(1, 20)
					.delayElements(Duration.ofMillis(1000 * 5))
					.map(n -> {
				if (n == 7)
					throw new RuntimeException("ErrorMessage");
				return n;
			});
			
			flux.subscribe(SubscriberUtil.getSubscriber());
			
			
		} catch (Throwable t) {
			System.out.println("=== Into catch block");
		}
		
		
		
		
		System.out.println("------------------- out of try-catch");
		
		
		try {
			Thread.sleep(1000 * 300);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	/*
	 * onSubscribe 1,2,3,4,5,6, ------------------- out of try-catch
	 */

	public static void error() {
		
		
		Mono<Integer> mono = Mono.error(new RuntimeException("ErrorMessage"));
		
		mono.subscribe(SubscriberUtil.getSubscriber());
	}

	public static void onErrorMap() {

		Flux.just(1, 2, 3, 4)
		.map(n -> {
			if (n == 2)
				throw new RuntimeException("ErrorMessage");
			return n;
		})
		.onErrorMap(ex -> new RuntimeException("Modified-ErrorMessage"))
		.subscribe(SubscriberUtil.getSubscriber());

	}

	public static void onErrorReturn() {

		Flux.just(1, 2, 3, 4).map(n -> {
			if (n == 2)
				throw new RuntimeException("ErrorMessage");
			return n;
		}).onErrorReturn(9)
		.subscribe(SubscriberUtil.getSubscriber());

	}

	public static void onErrorResume() {

		Flux.just(1, 2, 3, 4).map(n -> {

			if (n == 2)
				throw new RuntimeException("ErrorMessage");
			return n;

		}).onErrorResume(ex -> {
			return Flux.just(50, 60, 70);
		}).subscribe(SubscriberUtil.getSubscriber());

	}
}
