package com.nisum.operators.transform;

import java.util.Arrays;
import java.util.List;

import com.nisum.domain.Address;
import com.nisum.domain.Order;
import com.nisum.util.SubscriberUtil;

import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.util.function.Tuple2;

public class TransformingPublisher {

	protected static List<Order> orders = Arrays.asList(
			new Order("order1", Arrays.asList(new Address("Kothaguda"), new Address("Madhapur"))),
			new Order("order2", Arrays.asList(new Address("Ameerpet"), new Address("Secunderabad"))));
	
	

	public static void main(String[] args) {
		
		
		
	
		
		
		
		
//		map();
//		flatMap();
//		concatWith();
//		concat();
		zip();
//		zipWith();
		
//		zipMono();
//		zipMonoList();	
		
		
				
		
	}

	public static void map() {
		
		Flux<Order> strFlux = Flux.fromIterable(orders);
		
		Flux<String> intFlux = strFlux.map(order -> order.getOrderId());
		
		intFlux.subscribe(SubscriberUtil.getStrSubscriber());
	}

	public static void flatMap() {
		
		Flux<Order> strFlux = Flux.fromIterable(orders);
		
		
		//Flux<List<Address>> a = strFlux.map(order-> order.getAddressList());
		
		Flux<Address> intFlux = strFlux.flatMap(order -> Flux.fromIterable(order.getAddressList()));
	
		intFlux.subscribe(SubscriberUtil.getAddrSubscriber());
	}

	public static void concatWith() {
		Flux<Integer> flux1 = Flux.just(1, 2, 3, 4, 5);
		Flux<Integer> flux2 = Flux.just(6, 7, 8, 9, 10);
		
		//Flux.concat(sources)
		
		//Flux<Integer> f3 = flux1.concatWith(flux2);
		
		Flux<Integer> f3 = flux2.mergeWith(flux1);
		
		f3.subscribe(SubscriberUtil.getSubscriber());
		//flux1.concatWith(flux2).subscribe(SubscriberUtil.getSubscriber());
	}

	public static void concat() {
		Flux<Integer> flux1 = Flux.just(1, 2, 3, 4, 5);
		Flux<Integer> flux2 = Flux.just(6, 7, 8, 9, 10);
		Flux.concat(flux1, flux2).subscribe(SubscriberUtil.getSubscriber());
	}

	public static void zip() {
		
		Flux<Integer> flux1 = Flux.just(1, 2, 3);
		
		Flux<String> flux2 = Flux.just("One", "Two", "Three", "Four");
		
		Flux<Tuple2<Integer, String>> tuple = Flux.zip(flux1, flux2);
		
				
		Flux.zip(flux1, flux2).doOnNext(t -> {
			System.out.println(t.getT1() + "--------" + t.getT2());
		}).subscribe();
	}
	
	public static void zipMono() {
		Mono<Integer> Mono1 = Mono.just(1).map(n -> n * 2);
		Mono<String> Mono2 = Mono.just("One");
		//Mono<String> Mono2 = Mono.empty();
		
		//Mono<Tuple2<Integer, String>> tuple = Mono.zip(Mono1,Mono2);=		
		
		//Flux.zip(combinator, sources)
		
		Mono.zip(Mono1,Mono2).doOnNext(t -> {
			System.out.println(t.getT1() + "--------" + t.getT2());
		}).subscribe();
	}
	
	public static void zipMonoList() {
		
		
		Mono<List<Integer>> Mono1= Flux.just(1, 2, 3).map(n -> n * 2).collectList();
		//Mono<List<String>> Mono2 = Flux.just("One", "Two", "Three", "Four").collectList();
		Mono<List<Object>> Mono2 = Flux.empty().collectList();
		

		
		//Mono<Integer> Mono1 = Mono.just(1).map(n -> n * 2);
		//Mono<String> Mono2 = Mono.just("One");
		//Mono<String> Mono2 = Mono.empty();
		
		//Mono<Tuple2<Integer, String>> tuple = Mono.zip(Mono1,Mono2);=		
		
		Mono.zip(Mono1,Mono2).doOnNext(t -> {
			System.out.println(t.getT1() + "--------" + t.getT2());
		}).subscribe();
	}

	public static void zipWith() {
		Flux<Integer> flux1 = Flux.just(1, 2, 3).map(n -> n * 2);
		Flux<String> flux2 = Flux.just("One", "Two", "Three");
		flux2.zipWith(flux1).doOnNext(t -> {
			System.out.println(t.getT1() + "--------" + t.getT2());
		}).subscribe();
	}

	public static void error() {
		
		Flux.just(1, 2, 3, 4).map(n -> {
			if (n == 2)
				throw new RuntimeException("Sample Message");
			return n;
		})
		
		.onErrorMap(ex-> new RuntimeException("Modified"))
		
		.onErrorReturn(10)
		
		.onErrorResume(ex -> {
			return Flux.just(50, 60, 70);
		})
		
		.subscribe(SubscriberUtil.getSubscriber());
		
	}
	
	

}
